SuperStrict

Import brl.max2d
Import brl.stream
Import brl.filesystem
Import brl.linkedlist
Import brl.pngloader
Import "png.bmx"
Import "stringstreamLEGACY.bmx"
Import "pixels.bmx"
Import "wordwrap.bmx"
import "vector.bmx"

Function LoadFont:Font(url$)':Object)
	Local f:TStream=ReadFile(url)'ReadStream(url)
	If Not f Return Null
	Local r:Font=Font.Read(f)
	CloseStream f
	If _usefont=Null _usefont=r
	Assert r,"Failed to load font "+url
	Return r
End Function

Global _usefont:font=Null

Function SetFont(f:font)
	_usefont=f
End Function

Function DrawText(t$,x#,y#,f:font=Null)
	If Not f f=_usefont
	If Not f Print t;Return
	f.draw(t,x,y)
End Function
Function TextWidth%(t$,f:font=Null)
	If Not f f=_usefont
	If Not f Return 0
	Return f.size(t).x
End Function


Global _charfont:font=Null
Function fontcharwidth%(char%)
	Local f:font=_charfont
	If Not f Then f=_usefont
	If Not f Then Return 0
	Return f.charw[char]+f.hspacing
End Function


Type lin
	Field t$,l%,y%
End Type
Type Font
	Global lastlins:TList 'keeps track of the last list of lins formed by a draw function
	Field stagger%=0
	Field image:TImage
	Field charw%[256],charh%=0,maxw%=0
	Field base%=0,top%=0
	Field name$="unnamed",author$="unknown"
	Field hspacing%=0,vspacing%=0 'spacing modifier, defaults: character setting and character height
	'Field newline@=255 'newline character
	'Function Load:ImageFont(image_path$,def_path$="")
	'	Local this:Font=Font.Create()
	'	If def_path<>"" Then this.ReadDefinition(def_path)
	'End Function
	Const LALIGN@=0,RALIGN@=1,CENTER@=2
	Method height%()
		Return charh+vspacing
	End Method
	Method Draw:vector(text$,x%,y%,align%=LALIGN,limit:Vector=Null,visible%=1,nographics%=0,pix:TPixmap=Null)
		Local sx#=1,sy#=1
		If Not nographics GetScale(sx,sy)
		If sx=0 Or sy=0 Return New vector
		If Not image Return New Vector
		Local ret:Vector=New Vector
		Local limw%=0,limz%=0,limy%=0
		If limit Then limw=limit.x;limz=limit.z;limy=limit.y
		If limz Then text=Left(text,limz)
		Local linedat:TList
		If limw Then
			_charfont=Self
			WrapString(text,limw/sx,fontcharwidth,15)
			linedat=lastlinedata
		Else
			linedat=CreateList()
			Local ld:linedata=New linedata'linedata.Create("",0,0)
			linedat.addlast ld
			For Local i%=0 Until text.length
				If text[i]=10 Or text[i]=255
					ld=New linedata
					linedat.addlast ld
				Else
					ld.text:+Chr(text[i])
					ld.width:+fontcharwidth(text[i])
				EndIf
			Next
		EndIf
		Local yoff%=0
		For Local ld:linedata=EachIn linedat
			'If ld.text.length>1 And ld.text[ld.text.length-1]=32 And ld.text[ld.text.length-2]<>32 Then 
			'	ld.text=Left(ld.text,ld.text.length-1)
			'	ld.width:-fontcharwidth(32)
			'EndIf
			ld.width:*sx
			If limy And yoff+charh*sy>limy Then Exit
			ret.y=yoff+charh*sy
			If ld.width>ret.x Then ret.x=ld.width
			If visible Then
				Local xoff%=0
				If align=RALIGN
					Local axis%=limw
					'If Not axis Then axis=ret.x
					xoff=axis-ret.x'ld.width
				ElseIf align=CENTER' And limw
					Local axis%=limw
					'If Not axis Then axis=ret.x
					xoff=(axis-ret.x)/2'ld.width)/2
				EndIf
				line ld.text,x+xoff,y+yoff,nographics,pix
			EndIf
			yoff:+height()*sy
		Next
		Return ret
	End Method
	'limit.x : limit pixel width, limit.y : limit pixel height, limit.z : limit length in characters
	'p:tpixmap is a pixmap to render on to
	Method DrawOld:Vector(text$,x%,y%,align%=LALIGN,limit:Vector=Null,visible%=1,nographics%=0,p:TPixmap=Null)
		Local sx#=1,sy#=1
		If Not nographics GetScale(sx,sy)
		If Not image Return New Vector
		Local ret:Vector=New Vector
		Local dx%=0,dy%=0
		Local le%=Len(text)
		Local in:lin=New lin,lins:TList=CreateList()
		lins.addlast in;in.y=0
		If limit Then 
			If limit.z>0 le=Min(le,limit.z)
		EndIf
		Local lastbreakpos%=0,lastbreak%=0
		For Local pos%=1 To le
			Local char@=text[pos-1],nl%=newline(char)
			If char=Asc(" ") Or char=Asc("-") Then lastbreakpos=pos;lastbreak=char
			If nl Or (limit And limit.x And in.l+charw[char]*sx>limit.x)
				dy:+(vspacing+charh)*sy
				If in.l>0 in.l:-hspacing*sx
				If limit And limit.y And dy+charh*sy>limit.y Then Exit
				If (Not nl) And lastbreakpos<=pos And lastbreak>0 Then
					Local diff%=(pos-lastbreakpos)-1
					For Local rpos%=0 Until diff
						Local chart@=text[pos-1-rpos]
						in.l:-(hspacing+charw[chart])*sx
					Next
					in.t=Left(in.t,in.t.length-diff)
					pos:-diff
					ret.z:-diff
					'If lastbreak=Asc(" ") Then pos:+1
					lastbreakpos=0;lastbreak=0
				EndIf
				If in.l>ret.x ret.x=in.l
				in=New lin
				lins.addlast in
				in.y=dy
			EndIf
			If Not nl
				in.t:+Mid(text,pos,1)
				in.l:+(hspacing+charw[char])*sx
			EndIf
			ret.z:+1
		Next
		ret.y=dy+charh*sy
		If in.l>0 in.l:-hspacing*sx
		If in.l>ret.x ret.x=in.l
		If visible
			For Local l:lin=EachIn lins
				Local xx%=x
				If align=RALIGN
					If limit xx=x+(limit.x-l.l) Else xx=x+(ret.x-l.l)
				ElseIf align=CENTER
					If limit xx=x+(limit.x/2-l.l/2) Else xx=x+(ret.x/2-l.l/2)
				EndIf
				line l.t,xx,l.y+y,nographics,p
			Next
		EndIf
		lastlins=lins
		If ret.y Then ret.y:-vspacing
		Return ret
	End Method
	Method Size:Vector(text$,limit:vector=Null)
		Local limw%=0,limz%=0,limy%=0
		If limit Then limw=limit.x;limz=limit.z;limy=limit.y
		Local wrapped:TList=New TList
		If limw
			wrapped=wrapstring(text,limw,fontcharwidth)
		Else
			Local line$=""
			For Local i%=0 Until text.length
				If text[i]=255 Or text[i]=10
					wrapped.addlast line
					line=""
				Else
					line:+Chr(text[i])
				EndIf
			Next
			If line Then wrapped.addlast line
		EndIf
		Local maxw%=0,h%=0
		For Local str$=EachIn wrapped
			maxw=Max(maxw,linelength(str))
			h:+charh+vspacing
		Next
		If h Then h:-vspacing
		Return vector.Create(maxw,h,text.length)
		'Return DrawOld(text,0,0,LALIGN,limit,0,1)
	End Method
	Method linelength%(t$)
		Local sum%=0
		For Local i%=0 Until t.length
			sum:+charw[t[i]]
		Next
		If sum Then sum:-hspacing
		Return sum
	End Method
	
	Field pixrgb%=0,usepixrgb%=0
	Method setpixcolor(rgb%)
		pixrgb=rgb
		usepixrgb=1
	End Method
	Method clearpixcolor()
		usepixrgb=0
	End Method
	
	Method getpixel%(argb1%,argb2%)
		Local a1%=argb1 Shr 24
		Local a2%=argb2 Shr 24
		If a1>a2 Then a1=a2
		'Print Hex(argb1)+" :: "+Hex(argb2)+" => "+Hex((a1 Shl 24) | (argb2 & $ffffff))
		Return (a1 Shl 24) | (argb2 & $ffffff)
	End Method
	
	Method line%(text$,x%,y%,nographics%,p:TPixmap)
		If stagger Then x=x/stagger*stagger;y=y/stagger*stagger
		Local sx#=1,sy#=1
		If Not nographics GetScale(sx,sy)
		Local dx%=0,char%
		For Local z%=1 To Len(text)
			char=Asc(Mid(text,z,1))
			If p
				If usepixrgb
					For Local xx%=0 To maxw-1
						Local atx%=x+dx+xx
						If atx<0 Continue
						If atx>=p.width Exit
						For Local yy%=0 To charh-1
							Local rval%=ReadPixel(image.pixmaps[char],xx,yy)
							Local aty%=y+yy
							If aty<0 Continue
							If aty>=p.height Exit
							WritePixelAlpha p,atx,aty,getpixel(rval,pixrgb)
						Next
					Next
				Else
					For Local xx%=0 To maxw-1
					For Local yy%=0 To charh-1
						Local rval%=ReadPixel(image.pixmaps[char],xx,yy)
						'If rval & $ff000000>128' = $ff
						'	WritePixel p,x+dx+xx,y+yy,$ffffffff'rval
						'If rval & $ff000000
							'Local pval%=ReadPixel(p,xx,yy)
							'Local ar%=(rval&$ff000000)Shr 24,ap%=255-ar
							'Local dr%=(((rval&$ff0000)Shr 16)*ar+((pval&$ff0000)Shr 16)*ap)/$ff
							'Local dg%=(((rval&$ff00)Shr 8)*ar+((pval&$ff00)Shr 8)*ap)/$ff
							'Local db%=(((rval&$ff))*ar+((pval&$ff))*ap)/$ff
							'Local fval%=(dr Shl 16)+(dg Shl 8)+db
							WritePixelAlpha p,x+dx+xx,y+yy,rval
						'EndIf
					Next
					Next
				EndIf
			Else
				DrawImage image,x+dx,y,char
			EndIf
			dx:+(hspacing+charw[char])*sx
		Next
		Return dx-hspacing*sx
	End Method
	
	
	
	Method Write(f:TStream)
		WriteInt f,1953394535
		WriteShort f,base
		WriteShort f,top
		WritePixmapPNG f,constructpixmap()
		_WriteString f,name
		_WriteString f,author
		WriteInt f,charh
		WriteInt f,maxw
		WriteInt f,hspacing
		WriteInt f,vspacing
		WriteByte f,0'newline
		WriteIntArray f,charw
	End Method
	Method constructpixmap:TPixmap()
		Local p:TPixmap=CreatePixmap(ImageWidth(image)*16,ImageHeight(image)*16,PF_RGBA8888)
		Local w%=PixmapWidth(image.pixmaps[0])
		Local h%=PixmapHeight(image.pixmaps[0])
		For Local n%=0 To image.pixmaps.length-1
			For Local x%=0 To w-1
			For Local y%=0 To h-1
				WritePixel p,(n Mod 16)*w+x,(n/16)*h+y,ReadPixel(image.pixmaps[n],x,y)
			Next
			Next
		Next
		Return p
	End Method
	Function Read:Font(f:TStream)
		Local sig%=ReadInt(f),base%=-1,top%=-1
		If sig=1953394535 
			base=ReadShort(f)
			top=ReadShort(f)
		Else
			If sig<>1953394534 Return Null'RuntimeError "Failed to read font"
		EndIf
		Local n:Font=New Font
		Local p:TPixmap=ReadPixmapPNG(f)
		n.image=LoadAnimImage(p,PixmapWidth(p)/16,PixmapHeight(p)/16,0,256,0)
		n.name=_ReadString(f)
		n.author=_ReadString(f)
		n.charh=ReadInt(f)
		n.base=base;n.top=top
		If base=-1 n.base=n.charh
		If top=-1 n.top=0
		n.maxw=ReadInt(f)
		n.hspacing=ReadInt(f)
		n.vspacing=ReadInt(f)
		ReadByte f 'n.newline=ReadByte(f)
		n.charw=ReadIntArray(f)
		Return n
	End Function
	
	Rem 
	' convert from ibm character set or whatever the hell it is to ASCII
	Method standardize()
		Local npix:TPixmap[256]
		Local ncw%[256]
		For Local x%=0 Until 256
			npix[x]=image.pixmaps[x]
			ncw[x]=charw[x]
		Next
		'For Local x%=32 To 128
		'	set x,x
		'Next
		set 161,173 ' upside-down !
		set 162,155 ' cent
		set 163,156 ' 
		set 164,15 ' 
		set 165,157 ' 
		set 166,124 ' 
		set 167,21 ' 
		set 168,34 ' 
		set 171,174 ' 
		set 176,248 ' 
		set 177,241 ' 
		set 180,96 ' 
		set 181,230 ' 
		set 182,20 ' 
		set 183,249 ' 
		set 187,175 ' 
		set 188,172 ' 
		set 189,171 ' 
		set 191,168 ' 
		set 192,65 '  -> A
		set 193,65 '  -> A
		set 194,65 '  -> A
		set 195,65 '  -> A
		set 196,142 ' 
		set 197,143 ' 
		set 198,146 ' 
		set 199, ' 
		set 209, ' 
		set 200, ' 
		set 200, ' 
		set 200, ' 
		set 200, ' 
		set 200, ' 
		set 200, ' 
		set 200, ' 
		set 200, ' 
	End Method
	Method set(ni%,oi%)
		npix[ni]=image.pixmaps[oi]
		ncw[ni]=charw[oi]
	End Method
	EndRem
	
	Method export(path$)
		path=StripExt(path)
		Local p:TPixmap=constructpixmap()
		SavePixmapPNG p,path+".png"
		Local f:TStream=WriteFile(path+".dat")
		WriteString f,"SFNT"
		WriteInt f,1
		' null-terminated strings
		_WriteString f,name 
		_WriteString f,author
		'maxw=0
		'For Local x%=0 Until 256
		'	If charw[x]>maxw Then maxw=charw[x]
		'Next
		WriteInt f,maxw
		WriteInt f,charh
		WriteInt f,hspacing
		WriteInt f,vspacing
		WriteInt f,top
		WriteInt f,base
		WriteInt f,0 ' newline
		For Local x%=0 Until 256
			WriteInt f,charw[x]
		Next
		CloseFile f
	End Method
	
	Function comparesize%(o1:Object,o2:Object)
		Local sum1%,sum2%
		For Local x%=0 To 255
			sum1:+Font(o1).charw[x]
			sum2:+Font(o2).charw[x]
		Next
		Local a1%=(Font(o1).charh+Font(o1).vspacing)*(sum1/255.0+Font(o1).hspacing)
		Local a2%=(Font(o2).charh+Font(o2).vspacing)*(sum2/255.0+Font(o2).hspacing)
		If a1>a2 Return 1
		If a1=a2 Return 0
		Return -1
	End Function 
	Function comparename%(o1:Object,o2:Object)
		If Font(o1).name>Font(o2).name Return 1
		If Font(o1).name=Font(o2).name Return 0
		Return -1
	End Function 
	Function compareauthor%(o1:Object,o2:Object)
		If Font(o1).author>Font(o2).author Return 1
		If Font(o1).author=Font(o2).author Return 1
		Return -1
	End Function 
End Type


Function newline%(c%)
	Return c=$0a Or c=$0d Or c=$ff
End Function 




