SuperStrict

Import brl.blitz
Import "functionqueue.bmx"
Import "containers.bmx"

Type framelimiter
	Field targetmspf%=40,lastms%=MilliSecs(),fps%=0
	Field history:TList=CreateList(),keephistory%=128,historycount%=0
	Field task:functionqueue=functionqueue.Create(),lasttask%=MilliSecs()
	Method update() 'should be called immediately after the flip of the game loop
		Local diff%=targetmspf-(MilliSecs()-lastms)
		If (diff>5 Or (MilliSecs()-lasttask)>200) And task.front
			task.dequeuenode().data();lasttask=MilliSecs()
		ElseIf diff>0
			Delay diff
		EndIf
		Local elapsed%=MilliSecs()-lastms
		history.addfirst intcontainer.Create(elapsed);historycount:+1
		If historycount>keephistory Then
			history.removelast;historycount:-1
		EndIf
		fps=1000/Float(elapsed)
		lastms=MilliSecs()
	End Method
	Method addtask(dofunc())
		task.enqueue(dofunc)
		lasttask=MilliSecs()
	End Method
	Function Create:framelimiter(targetfps%=0) 'target FPS is converted to target ms/f
		Local f:framelimiter=New framelimiter
		If targetfps=0 f.targetmspf=0 Else f.setfps(targetfps)
		f.lastms=MilliSecs()
		Return f
	End Function
	Method setfps(targetfps%)
		targetmspf=1000/Float(targetfps)
	End Method
	Method setmspf(targetmsf%)
		targetmspf=targetmsf
	End Method
End Type
