Import brl.polledinput
Import brl.linkedlist
Import brl.stream

Function createkey:key(n%,m%=0,d%=-1,delaymod!=1)
	Local k:key=New key
	k.addkey n,m
	k.keydelay=d
	k.delaymod=delaymod
	Return k
End Function

Type Key
	Field keys:TList=CreateList()
	Field keydelay%=210,currentdelay%=-1,mindelay%=8
	Field delaymod!=1
	
	Const none%=%000
	Const any%=%1000
	Const ctrl%=%100,shift%=%010,alt%=%001
	Const ctrlshift%=%110,shiftctrl%=%110,ctrlalt%=%101,altctrl%=%101,shiftalt%=%011,altshift%=%011
	Const ctrlaltshift%=%111,ctrlshiftalt%=%111,altshiftctrl%=%111,altctrlshift%=%111,shiftctrlalt%=%111,shiftaltctrl%=%111
	
	Method write(f:TStream)
		WriteInt f,keydelay
		WriteInt f,keys.count()
		For Local k:control_key=EachIn keys
			k.write f
		Next
	End Method
	Function read:key(f:TStream)
		Local n:key=New key
		n.keydelay=ReadInt(f)
		For Local i%=0 Until ReadInt(f)
			n.keys.addlast control_key.read(f)
		Next
		Return n
	End Function
	
	Method setmod(kind%)
		For Local k:control_key=EachIn keys
			k.modkind=kind
		Next
	End Method
	Function Create:Key(n0%=-1,mod0%=0,n1%=-1,mod1%=0,n2%=-1,mod2%=0,n3%=-1,mod3%=0)
		Local k:Key=New Key
		If n0>=0 k.AddKey n0,mod0
		If n1>=0 k.AddKey n1,mod1
		If n2>=0 k.AddKey n2,mod2
		If n3>=0 k.AddKey n3,mod3
		Return k
	End Function
	Method AddKey:control_key(v@,modkind%=0)
		Local n:control_key=control_key.Create(v,modkind)
		keys.addlast n
		Return n
	End Method
	Method RemoveKey%(n@,modkind%=-1)
		Local ret%=0
		For Local c:control_key=EachIn keys
			If c.num=n And (c.modkind=modkind Or modkind=-1) Then keys.remove c;ret=1
		Next
		Return ret
	End Method
	Method get%()
		Local resetdelay%=1
		Local isget%=0
		For Local k:control_key=EachIn keys
			If (Not isget) And k.get(currentdelay)
				isget=1
			EndIf
			If resetdelay And k.down() Then
				resetdelay=0
			EndIf
			If isget And (Not resetdelay) Then Exit
		Next
		If resetdelay
			currentdelay=keydelay
		ElseIf keydelay<>-1
			currentdelay=Max(mindelay,currentdelay*delaymod)
		EndIf
		Return isget
	End Method
	method released%()
		For Local k:control_key=EachIn keys
			If k.released() Return 1
		Next
		return 0
	end method
	method hit%()
		For Local k:control_key=EachIn keys
			If k.hit() Return 1
		Next
		return 0
	end method
	Method down%()
		For Local k:control_key=EachIn keys
			If k.down() Return 1
		Next
		Return 0
	End Method
	Method downtime%()
		Local ret%=0,now%=MilliSecs()
		For Local k:control_key=EachIn keys
			If k.down() Then ret=Max(ret,now-k.lastms)
		Next
		Return ret
	End Method
	Method flush()
		For Local k:control_key=EachIn keys
			k.flush
		Next
	End Method
End Type

Type control_key
	Field num@,lastms%,init%=1
	Field modkind%=0
	field wasdown%
	
	Method write(f:TStream)
		WriteByte f,num
		WriteByte f,modkind
	End Method
	Function read:control_key(f:TStream)
		Local n:control_key=New control_key
		n.num=ReadByte(f)
		n.modkind=ReadByte(f)
		Return n
	End Function
	
	Method flush()
		lastms=MilliSecs()
	End Method
	Function Create:control_key(n@,modkind%=0)
		Local c:control_key=New control_key
		c.num=n;c.modkind=modkind
		Return c
	End Function
	Method get%(keydelay%)
		If KeyDown(num) And ((modkind=modkeys) Or (modkind=key.any)) 'ismod
			If MilliSecs()-lastms=>keydelay And keydelay>=0 lastms=MilliSecs();Return 1
			If init init=0;Return 1
		Else
			init=1;lastms=MilliSecs()
		EndIf
		Return 0
	End Method
	method released%()
		return self.wasdown and (not KeyDown(num))
	end method
	method hit%()
		return KeyHit(num)
	end method
	Method down%()
		self.wasdown = KeyDown(num)
		return self.wasdown
	End Method
End Type

Global modkeys%=0
Function _keys_ctrl%()
	Return KeyDown(key_lcontrol) | KeyDown(key_rcontrol)
End Function
Function _keys_shift%()
	Return KeyDown(key_lshift) | KeyDown(key_rshift)
End Function
Function _keys_alt%()
	Return KeyDown(key_lalt) | KeyDown(key_ralt)
End Function
Function updatemodkeys()
	modkeys=(_keys_ctrl() Shl 2)|(_keys_shift() Shl 1)|(_keys_alt())
End Function






