SuperStrict
Import brl.math

Type Vector
	Field x%,y%,z%
	Function Create:Vector(x%=0,y%=0,z%=0)
		Local n:Vector=New Vector
		n.x=x;n.y=y;n.z=z
		Return n
	End Function
	Method Copy:Vector()
		Return Create(x,y,z)
	End Method
	Method Magnitude#()
		Return Sqr(x*x+y*y+z*z)
	End Method
	'Method Output(dim%=2)
	'	If dim=1
	'		Print x
	'	ElseIf dim=2
	'		Print x+","+y
	'	ElseIf dim>2
	'		Print x+","+y+","+z
	'	EndIf
	'End Method
	Method ToString$()
		Return x+","+y+","+z
	End Method
	Function Sort%(o1:Object,o2:Object)
		If Vector(o1).Magnitude()<Vector(o2).Magnitude() Return -1
		Return 1
	End Function
	Method write(f:TStream)
		If z=0
			If y=0
				If x=0
					WriteByte f,0
				Else
					WriteByte f,1
					WriteInt f,x
				EndIf
			Else
				WriteByte f,2
				WriteInt f,x
				WriteInt f,y
			EndIf
		Else
			WriteByte f,3
			WriteInt f,x
			WriteInt f,y
			WriteInt f,z
		EndIf
	End Method
	Function read:vector(f:TStream)
		Local b%=ReadByte(f),v:vector=New vector
		If b>0 v.x=ReadInt(f)
		If b>1 v.y=ReadInt(f)
		If b>2 v.z=ReadInt(f)
		Return v
	End Function
End Type

Type rect
	Field pos:vector,size:vector
	Function Create:rect(x%,y%,w%,h%)
		Local r:rect=New rect
		r.pos=vector.Create(x,y)
		r.size=vector.Create(w,h)
		Return r
	End Function
	Method Overlaps%(o:rect)
		If pos.x>(o.pos.x+o.size.x) Or o.pos.x>(pos.x+size.x) Return 0
		If pos.y>(o.pos.y+o.size.y) Or o.pos.y>(pos.y+size.y) Return 0
		Return 1
	End Method
	Method ContainsPoint%(point:vector)
		If point.x<pos.x Or point.x>pos.x+size.x Return 0
		If point.y<pos.y Or point.y>pos.y+size.y Return 0
		Return 1
	End Method 
	Method Contains%(x%,y%)
		If x<pos.x Or x>pos.x+size.x Return 0
		If y<pos.y Or y>pos.y+size.y Return 0
		Return 1
	End Method 
	Method write(f:TStream)
		pos.write f
		size.write f
	End Method
	Function read:rect(f:TStream)
		Local r:rect=New rect
		r.pos=vector.read(f)
		r.size=vector.read(f)
		Return r
	End Function
End Type
